#!/usr/bin/perl
#
#	Copyright 2002 Matthew Colyer
#	GPL V2.0 see COPYING
#
#	This file takes the data from Evolution and transfers 
#	it to the Zaurus.

use Net::FTP;
use Net::Telnet;

require 'e2z-cal.pl';
require 'e2z-tasks.pl';
require 'e2z-contacts.pl';

#Configuration information
my $zaurus_ip_addr = "192.168.2.201";
my $zaurus_port = 4242;
my $zaurus_user = "root";
my $zaurus_password = "";

#Files to replace
my $root_path = "/home/root/Applications";
my @files = ("addressbook/addressbook.xml", "todolist/todolist.xml", "datebook/datebook.xml");

#Process the files
print "Processing the Calendar: ";
e2z_cal("$ENV{'HOME'}/evolution/local/Calendar/calendar.ics", "datebook.xml");
print "Completed\n";
print "Processing the Task list: ";
e2z_tasks("$ENV{'HOME'}/evolution/local/Tasks/tasks.ics", "todolist.xml");
print "Completed\n";
print "Processing the Contact list: ";
e2z_contacts("$ENV{HOME}/evolution/local/Contacts/addressbook.db","addressbook-2.xml");
print "Completed\n";

#Close all applications on Zaurus
print "Closing all applications on the Zaurus: ";
my $qcop = new Net::Telnet (Telnetmode => 0);
$qcop->open(Host => $zaurus_ip_addr,
            Port => ($zaurus_port+1));
$qcop->print("USER $zaurus_user");
$qcop->print("PASS $zaurus_password");
$qcop->print("CALL QPE/System quit()");
$qcop->print("QUIT");
print "Completed\n";

#Upload the files ot the Zaurus
print "Establishing an FTP Connection\n";
my $ftp = Net::FTP->new($zaurus_ip_addr, Debug => 0, Port => $zaurus_port) 
	or die "Error: could not establish an FTP connection\n";
$ftp->login($zaurus_user,$zaurus_port);
$ftp->cwd($root_path);
foreach $file (@files) {
	$file =~ /.*\/(.*)/;
	print "\tUploading $1: ";
	$ftp->put($1,$file);
	print "Completed\n";
}

$ftp->quit;
print "Completed\n";