#!/usr/bin/perl
#
#	Copyright 2002 Matthew Colyer
#	GPL V2.0 see COPYING
#
#	Converts calendar data from Zaurus to Evolution's format.

use strict ;
use vars qw( ) ;
use XML::Parser;


sub z2e_cal{
	my $evo_file = shift;
	my $z_file = shift;
	
	open(CALENDARFILE, ">$evo_file");
	print CALENDARFILE "BEGIN:VCALENDAR\n";
	print CALENDARFILE "VERSION:2.1\n";
	
	my $parser = new XML::Parser(ErrorContext => 2);
	$parser->setHandlers(Start => \&calendar_element_handler);
	$parser->parsefile($z_file);
	
	print CALENDARFILE "END:VCALENDAR\n";
	close(CALENDARFILE);
	
}

sub calendar_element_handler
{
	my $expat = shift; my $element = shift;
	my %vcard;
	my $file;
	
	# Gather all the attributes of the element
    while (@_) {
    	my $attr = shift;
    	my $val = shift;
    	
    	$vcard{$attr} = $val;		
    }
    if (!($vcard{'uid'} eq "")){
    	print CALENDARFILE "BEGIN:VEVENT\n";
    	my ($s, $m, $h, $d, $M, $y, $e, $f, $g) = gmtime(time);
    	$M += 1;
    	$y += 1900;
    	print CALENDARFILE "UID:".sprintf('%02d%02d%02dT%02d%02d%02dZ',$y,$M,$d,$h,$m,$s).$vcard{'uid'}."\@light\n";
    	print CALENDARFILE "DTSTAMP:".sprintf('%02d%02d%02dT%02d%02d%02dZ',$y,$M,$d,$h,$m,$s)."\n";
    	print CALENDARFILE "LAST-MODIFIED:".sprintf('%02d%02d%02dT%02d%02d%02dZ',$y,$M,$d,$h,$m,$s)."\n";
    	if (!($vcard{'description'} eq "")){
    		print CALENDARFILE "SUMMARY:".$vcard{'description'}."\n";
    	}
    	if (!($vcard{'note'} eq "")){
    		print CALENDARFILE "DESCRIPTION:".$vcard{'note'}."\n";
    	}
    	if (!($vcard{'location'} eq "")){
    		print CALENDARFILE "LOCATION:".$vcard{'location'}."\n";
    	}
    	if (!($vcard{'start'} eq "0")){
    		my ($s, $m, $h, $d, $M, $y, $e, $f, $g) = localtime($vcard{'start'});
    		$M += 1;
    		$y += 1900;
    		print CALENDARFILE "DTSTART;TZID=/softwarestudio.org/Olson_20011030_5/America/New_York:".
    				sprintf('%02d%02d%02dT%02d%02d%02d',$y,$M,$d,$h,$m,$s)."\n";
    	}
    	if (!($vcard{'end'} eq "0")){
   		 my ($s, $m, $h, $d, $M, $y, $e, $f, $g) = localtime($vcard{'end'});
    		$M += 1;
    		$y += 1900;
    		print CALENDARFILE "DTEND;TZID=/softwarestudio.org/Olson_20011030_5/America/New_York:".
    				sprintf('%02d%02d%02dT%02d%02d%02d',$y,$M,$d,$h,$m,$s)."\n";
    	}
    	
    	#Alarm
    	if (!($vcard{'alarm'} eq "")){
	    	print CALENDARFILE "BEGIN:VALARM\n";
	    	print CALENDARFILE "X-EVOLUTION-ALARM-UID:".sprintf('%02d%02d%02dT%02d%02d%02dZ',$y,$M,$d,$h,$m,$s).$vcard{'uid'}."\@light\n";
	    	if ($vcard{'sound'} eq "silent"){
	    		print CALENDARFILE "TRIGGER;VALUE=DURATION;RELATED=START:-PT$vcard{'alarm'}M\n";
	    		print CALENDARFILE "ACTION:DISPLAY\n";
	    	}
	    	if ($vcard{'sound'} eq "loud"){
	    		print CALENDARFILE "TRIGGER;VALUE=DURATION;RELATED=START:-PT$vcard{'alarm'}M\n";
	    		print CALENDARFILE "ACTION:AUDIO\n";
	    	}
	    	if (!($vcard{'description'} eq "")){
	    		print CALENDARFILE "DESCRIPTION:".$vcard{'description'}."\n";
	    	}
	 	   print CALENDARFILE "END:VALARM\n";
 	   }
 	   print CALENDARFILE "END:VEVENT\n";
    }
}

#Leave this in here
1;
