#!/usr/bin/perl
#
#	Copyright 2002 Matthew Colyer
#	GPL V2.0 see COPYING
#
#	Converts task data from Zaurus to Evolution's format.

use strict ;
use vars qw( ) ;
use XML::Parser;

sub z2e_tasks{
	my $evo_file = shift;
	my $z_file = shift;
	
	open(TASKFILE, ">$evo_file");
	print TASKFILE "BEGIN:VCALENDAR\n";
	print TASKFILE "VERSION:2.1\n";
	
	my $parser = new XML::Parser(ErrorContext => 2);
	$parser->setHandlers(Start => \&task_element_handler);
	$parser->parsefile($z_file);
	
	print TASKFILE "END:VCALENDAR\n";
	close(TASKFILE);
}

sub task_element_handler
{
	my $expat = shift; my $element = shift;
	my %vcard;
	my $file;
	
	# Gather all the attributes of the element
    while (@_) {
    	my $attr = shift;
    	my $val = shift;
    	
    	$vcard{$attr} = $val;		
    }
    if (!($vcard{'Uid'} eq "")){
    	print TASKFILE "BEGIN:VTODO\n";
    	print TASKFILE "UID:".$vcard{'Uid'}."\n";
    	if (!($vcard{'Description'} eq "")){
    		print TASKFILE "SUMMARY:".$vcard{'Description'}."\n";
    	}
    	if (!($vcard{'HasDate'} eq "0")){
    		print TASKFILE "DUE;VALUE=DATE:".$vcard{'DateYear'}.$vcard{'DateMonth'}.
    		$vcard{'DateDay'}."T000000\n";
    	}
    	if ($vcard{'Completed'} eq "0"){
    		print TASKFILE "STATUS:NOT-STARTED\n";
    	}else{
    		print TASKFILE "STATUS:COMPLETED\n";    		
    	}
    	
    	#priorities don't match up on Zaurus
    	if ($vcard{'Priority'} eq "1" or $vcard{'Priority'} eq "2"){
    		print TASKFILE "PRIORITY:3\n";
    	}
    	if ($vcard{'Priority'} eq "3"){
    		print TASKFILE "PRIORITY:5\n";
    	}
    	if ($vcard{'Priority'} eq "4" or $vcard{'Priority'} eq "5"){
    		print TASKFILE "PRIORITY:7\n";
    	}
    	
    	print TASKFILE "END:VTODO\n";
    }
}

#Leave this in here
1;