#!/usr/bin/perl
#
#	Copyright 2002 Matthew Colyer
#	GPL V2.0 see COPYING
#

use strict ;
use BerkeleyDB ;
use vars qw( %contact_db) ;
use Net::FTP;
use XML::Parser;

require 'z2e-tasks.pl';
require 'z2e-contacts.pl';
require 'z2e-cal.pl';

my $zaurus_ip_addr = "192.168.2.201";
my $zaurus_port = 4242;
my $zaurus_user = "root";
my $zaurus_password = "";


my $root_path = "/home/root/Applications";
my @files = ("addressbook/addressbook.xml", "todolist/todolist.xml", "datebook/datebook.xml");
my $file;

#Get the files
print "Establishing an FTP Connection:\n";
my $ftp = Net::FTP->new($zaurus_ip_addr, Debug => 0, Port => $zaurus_port) 
	or die "Error: could not establish an FTP connection\n";
$ftp->login($zaurus_user,$zaurus_port);
$ftp->cwd($root_path);
foreach $file (@files) {
	print "\tDownloading $file: ";
	$ftp->get($file);
	print "Completed\n";
}
$ftp->quit;
print "Completed\n";

#Process the Data
print "Processing Contacts: ";
z2e_contacts("$ENV{'HOME'}/evolution/local/Contacts/addressbook.db","addressbook.xml");
print "Completed\n";
print "Processing Tasks: ";
z2e_tasks("$ENV{'HOME'}/evolution/local/Tasks/tasks.ics","todolist.xml");
print "Completed\n";
print "Processing Calendar: ";
z2e_cal("$ENV{'HOME'}/evolution/local/Calendar/calendar.ics","datebook.xml");
print "Completed\n";


